/* contrôler 3 servomoteurs à l'aide de 3 résistances variables*/

// --- Fonctionnalités utilisées ---
// Utilise la conversion analogique numérique 10bits sur les voies analogiques  analog 0,  analog 1,  analog 2, 
// Utilise les servomoteurs 

// --- Circuit à réaliser ---

// Connecter  sur la broche 2 (configurée en sortie) broche de commande du servomoteur 0 alimenté par alim externe
// Connecter  sur la broche 3 (configurée en sortie) broche de commande du servomoteur 1 alimenté par alim externe
// Connecter  sur la broche 4 (configurée en sortie) broche de commande du servomoteur 2 alimenté par alim externe

// Broche Analog 0 (=broche 14) en entrée Analogique 
// Broche Analog 1 (=broche 15) en entrée Analogique 
// Broche Analog 2 (=broche 16) en entrée Analogique 

#include <Servo.h> // librairie pour servomoteur

// --- Déclaration des constantes ---
const int POS_MIN=0; // largeur impulsion pour position 0° servomoteur 
                       // POS_MIN=550 pour futaba S3003 
const int POS_MAX=158; // largeur impulsion pour position 180° servomoteur
             // POS_MAS=2330 pour futaba s3003

// --- constantes des broches ---

const int SERVO_0=2; //declaration constante de broche 
const int SERVO_1=3; //declaration constante de broche 
const int SERVO_2=4; //declaration constante de broche 

const int Voie_0=0; //declaration constante de broche analogique
const int Voie_1=1; //declaration constante de broche analogique
const int Voie_2=2; //declaration constante de broche analogique

// --- Déclaration des variables globales ---
int mesure_brute=0;// Variable pour acquisition résultat brut de conversion analogique numérique
float mesuref=0.0;// Variable pour calcul résultat décimal de conversion analogique numérique

int angle_servo_0=0; // variable pour angle du servomoteur
int angle_servo_1=0; // variable pour angle du servomoteur
int angle_servo_2=0; // variable pour angle du servomoteur

// --- Déclaration des objets utiles pour les fonctionnalités utilisées ---
Servo mon_servo_0;  // crée un objet servo pour contrôler le servomoteur
Servo mon_servo_1;  // crée un objet servo pour contrôler le servomoteur
Servo mon_servo_2;  // crée un objet servo pour contrôler le servomoteur


//**************** FONCTION SETUP = Code d'initialisation *****
// La fonction setup() est exécutée en premier et 1 seule fois, au démarrage du programme

void setup()   { // debut de la fonction setup()

// --- ici instructions à exécuter au démarrage --- 

mon_servo_0.attach(SERVO_0, POS_MIN, POS_MAX);  // attache l'objet servo à la broche de commande du servomoteur
mon_servo_1.attach(SERVO_1, POS_MIN, POS_MAX);  // attache l'objet servo à la broche de commande du servomoteur
mon_servo_2.attach(SERVO_2, POS_MIN, POS_MAX);  // attache l'objet servo à la broche de commande du servomoteur

// ------- Broches en sortie -------  

pinMode(SERVO_0, OUTPUT); //met la broche en sortie 
pinMode(SERVO_1, OUTPUT); //met la broche en sortie 
pinMode(SERVO_2, OUTPUT); //met la broche en sortie 

// ------- Broches en entrée -------  


// ------- Activation du rappel au + interne des broches en entrée si nécessaire -------  


} // fin de la fonction setup()
// ********************************************************************************

//*************** FONCTION LOOP = Boucle sans fin = coeur du programme *************
// la fonction loop() s'exécute sans fin en boucle aussi longtemps que l'Arduino est sous tension

void loop(){ // debut de la fonction loop()

// --- ici instructions à exécuter par le programme principal --- 

//========== SERVO_0 ===============
// acquisition conversion analogique numérique (100µs env.) sur broche analogique indiquée - résultat 10bits (0-1023) 
mesure_brute=analogRead(Voie_0); 

angle_servo_0=map(mesure_brute,0,1023,0,180); // convertit la valeur mesurée comprise entre 0 et 1023 en un angle entre 0 et 180
// map(value, fromLow, fromHigh, toLow, toHigh); // permet changement d'échelle simplifié

mon_servo_0.write(angle_servo_0); // positionne le servo à l'angle voulu

//========== SERVO_1 ===============
// acquisition conversion analogique numérique (100µs env.) sur broche analogique indiquée - résultat 10bits (0-1023) 
mesure_brute=analogRead(Voie_1); 

angle_servo_1=map(mesure_brute,0,1023,0,180); // convertit la valeur mesurée comprise entre 0 et 1023 en un angle entre 0 et 180
// map(value, fromLow, fromHigh, toLow, toHigh); // permet changement d'échelle simplifié

mon_servo_1.write(angle_servo_1); // positionne le servo à l'angle voulu

//========== SERVO_2 ===============
// acquisition conversion analogique numérique (100µs env.) sur broche analogique indiquée - résultat 10bits (0-1023) 
mesure_brute=analogRead(Voie_2); 

angle_servo_2=map(mesure_brute,0,1023,0,180); // convertit la valeur mesurée comprise entre 0 et 1023 en un angle entre 0 et 180
// map(value, fromLow, fromHigh, toLow, toHigh); // permet changement d'échelle simplifié

mon_servo_2.write(angle_servo_2); // positionne le servo à l'angle voulu

} // fin de la fonction loop() - le programme recommence au début de la fonction loop sans fin

